sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=95
left=100
caption="ChessBoard 0.1 - Beta4 25/04"
tile=1
tileLayout=1
End CompInit
Dim boardGroup as group
boardGroup = MakeComponent("group",form1)
CompInit boardGroup
proto="boardGroup"
caption="Board"
height=260
width=235
look=1
tile=1
visible=1
End CompInit
Dim board as gadget
board = MakeComponent("gadget",boardGroup)
CompInit board
proto="board"
width=160
height=160
End CompInit
board.name="board"
boardGroup.name="boardGroup"
Dim info as group
info = MakeComponent("group",form1)
CompInit info
proto="info"
caption="Info"
height=260
width=150
look=1
tile=1
visible=1
End CompInit
Dim label1 as label
label1 = MakeComponent("label",info)
CompInit label1
proto="label1"
caption="Selected Piece:"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label1.name="label1"
Dim picture14 as picture
picture14 = MakeComponent("picture",info)
CompInit picture14
proto="picture14"
width=20
height=20
visible=1
End CompInit
picture14.name="picture14"
Dim spacer3 as spacer
spacer3 = MakeComponent("spacer",info)
CompInit spacer3
proto="spacer3"
visible=1
End CompInit
spacer3.name="spacer3"
Dim label2 as label
label2 = MakeComponent("label",info)
CompInit label2
proto="label2"
caption="Tile: "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label2.name="label2"
Dim label3 as label
label3 = MakeComponent("label",info)
CompInit label3
proto="label3"
caption="trnsState:  "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label3.name="label3"
Dim spacer1 as spacer
spacer1 = MakeComponent("spacer",info)
CompInit spacer1
proto="spacer1"
look=4
width=125
visible=1
End CompInit
spacer1.name="spacer1"
Dim label6 as label
label6 = MakeComponent("label",info)
CompInit label6
proto="label6"
caption="Player's turn: "
sizeVControl=3
sizeHControl=3
visible=1
End CompInit
label6.name="label6"
Dim label7 as label
label7 = MakeComponent("label",info)
CompInit label7
proto="label7"
caption="White"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label7.name="label7"
Dim spacer4 as spacer
spacer4 = MakeComponent("spacer",info)
CompInit spacer4
proto="spacer4"
visible=1
End CompInit
spacer4.name="spacer4"
Dim Restart as button
Restart = MakeComponent("button",info)
CompInit Restart
proto="Restart"
caption="Restart"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Restart.name="Restart"
Dim spacer6 as spacer
spacer6 = MakeComponent("spacer",info)
CompInit spacer6
proto="spacer6"
visible=1
End CompInit
spacer6.name="spacer6"
Dim sound as toggle
sound = MakeComponent("toggle",info)
CompInit sound
proto="sound"
caption="Sound"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
sound.name="sound"
Dim stats as toggle
stats = MakeComponent("toggle",info)
CompInit stats
proto="stats"
caption="Show Stats."
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
stats.name="stats"
Dim button8 as button
button8 = MakeComponent("button",info)
CompInit button8
proto="button8"
caption="Force Comp. Move"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button8.name="button8"
Dim computer as toggle
computer = MakeComponent("toggle",info)
CompInit computer
proto="computer"
caption="blk = computer"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
computer.name="computer"
Dim label22 as label
label22 = MakeComponent("label",info)
CompInit label22
proto="label22"
caption="Last Move:              "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label22.name="label22"
info.name="info"
Dim group3 as group
group3 = MakeComponent("group",form1)
CompInit group3
proto="log"
caption="Log"
height=260
width=194
look=1
tile=1
End CompInit
Dim log as text
log = MakeComponent("text",group3)
CompInit log
proto="log"
height=200
width=170
End CompInit
log.name="log"
log.visible=1
Dim Clear_Log as button
Clear_Log = MakeComponent("button",group3)
CompInit Clear_Log
proto="Clear_Log"
caption="Clear Log"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Clear_Log.name="Clear_Log"
group3.name="group3"
form1.width=393
form1.height=287
form1.name="form1"
Dim dialog1 as dialog
dialog1 = MakeComponent("dialog","app")
CompInit dialog1
proto="dialog1"
left=637
top=10
tile=1
tileLayout=1
caption="Spielfiguren"
End CompInit
Dim picture2 as picture
picture2 = MakeComponent("picture",dialog1)
CompInit picture2
proto="picture2"
width=25
height=25
visible=1
End CompInit
picture2.graphic=GetComplex(0)
picture2.name="picture2"
Dim picture3 as picture
picture3 = MakeComponent("picture",dialog1)
CompInit picture3
proto="picture3"
width=25
height=25
visible=1
End CompInit
picture3.graphic=GetComplex(1)
picture3.name="picture3"
Dim picture4 as picture
picture4 = MakeComponent("picture",dialog1)
CompInit picture4
proto="picture4"
width=25
height=25
visible=1
End CompInit
picture4.graphic=GetComplex(2)
picture4.name="picture4"
Dim picture5 as picture
picture5 = MakeComponent("picture",dialog1)
CompInit picture5
proto="picture5"
width=25
height=25
visible=1
End CompInit
picture5.graphic=GetComplex(3)
picture5.name="picture5"
Dim picture6 as picture
picture6 = MakeComponent("picture",dialog1)
CompInit picture6
proto="picture6"
width=25
height=25
visible=1
End CompInit
picture6.graphic=GetComplex(4)
picture6.name="picture6"
Dim picture7 as picture
picture7 = MakeComponent("picture",dialog1)
CompInit picture7
proto="picture7"
width=25
height=25
visible=1
End CompInit
picture7.graphic=GetComplex(5)
picture7.name="picture7"
Dim picture8 as picture
picture8 = MakeComponent("picture",dialog1)
CompInit picture8
proto="picture8"
width=25
height=25
visible=1
End CompInit
picture8.graphic=GetComplex(6)
picture8.name="picture8"
Dim picture9 as picture
picture9 = MakeComponent("picture",dialog1)
CompInit picture9
proto="picture9"
width=25
height=25
visible=1
End CompInit
picture9.graphic=GetComplex(7)
picture9.name="picture9"
Dim picture10 as picture
picture10 = MakeComponent("picture",dialog1)
CompInit picture10
proto="picture10"
width=25
height=25
visible=1
End CompInit
picture10.graphic=GetComplex(8)
picture10.name="picture10"
Dim picture11 as picture
picture11 = MakeComponent("picture",dialog1)
CompInit picture11
proto="picture11"
width=25
height=25
visible=1
End CompInit
picture11.graphic=GetComplex(9)
picture11.name="picture11"
Dim picture12 as picture
picture12 = MakeComponent("picture",dialog1)
CompInit picture12
proto="picture12"
width=25
height=25
visible=1
End CompInit
picture12.graphic=GetComplex(10)
picture12.name="picture12"
Dim picture13 as picture
picture13 = MakeComponent("picture",dialog1)
CompInit picture13
proto="picture13"
width=25
height=25
visible=1
End CompInit
picture13.graphic=GetComplex(11)
picture13.name="picture13"
Dim picture1 as picture
picture1 = MakeComponent("picture",dialog1)
CompInit picture1
proto="picture1"
width=20
height=20
visible=1
End CompInit
picture1.name="picture1"
Dim label4 as label
label4 = MakeComponent("label",dialog1)
CompInit label4
proto="label4"
caption="label4"
visible=1
End CompInit
label4.name="label4"
dialog1.name="dialog1"
dialog1.width=280
dialog1.height=140
Dim dialog2 as dialog
dialog2 = MakeComponent("dialog","app")
CompInit dialog2
proto="dialog2"
left=221
top=216
tile=1
caption="Whe have a winner..."
End CompInit
Dim Won_String as label
Won_String = MakeComponent("label",dialog2)
CompInit Won_String
proto="Won_String"
caption=""
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Won_String.name="Won_String"
Dim spacer2 as spacer
spacer2 = MakeComponent("spacer",dialog2)
CompInit spacer2
proto="spacer2"
sizeHControl=2
look=4
visible=1
End CompInit
spacer2.name="spacer2"
Dim OK as button
OK = MakeComponent("button",dialog2)
CompInit OK
proto="OK"
caption="OK"
sizeHControl=3
sizeVControl=3
closeDialog=1
default=1
visible=1
End CompInit
OK.name="OK"
dialog2.height=74
dialog2.width=156
dialog2.name="dialog2"
Dim timer1 as timer
timer1 = MakeComponent("timer","app")
CompInit timer1
proto="timer1"
End CompInit
timer1.name="timer1"
Dim dialog3 as dialog
dialog3 = MakeComponent("dialog","app")
CompInit dialog3
proto="dialog3"
left=235
top=228
tile=1
caption="Pawn promotion!"
tileLayout=1
type=2
helpContext=""
End CompInit
Dim button4 as button
button4 = MakeComponent("button",dialog3)
CompInit button4
proto="button4"
caption=""
sizeHControl=3
sizeVControl=3
closeDialog=1
visible=1
End CompInit
button4.name="button4"
Dim button5 as button
button5 = MakeComponent("button",dialog3)
CompInit button5
proto="button5"
caption=""
sizeHControl=3
sizeVControl=3
closeDialog=1
visible=1
End CompInit
button5.name="button5"
Dim button6 as button
button6 = MakeComponent("button",dialog3)
CompInit button6
proto="button6"
caption=""
sizeHControl=3
sizeVControl=3
closeDialog=1
visible=1
End CompInit
button6.name="button6"
Dim button7 as button
button7 = MakeComponent("button",dialog3)
CompInit button7
proto="button7"
caption=""
sizeHControl=3
sizeVControl=3
closeDialog=1
visible=1
End CompInit
button7.name="button7"
dialog3.height=49
dialog3.width=134
dialog3.name="dialog3"
Dim sound1 as sound
sound1 = MakeComponent("sound","app")
CompInit sound1
proto="sound1"
End CompInit
sound1.name="sound1"
Dim statisticsWindow as dialog
statisticsWindow = MakeComponent("dialog","app")
CompInit statisticsWindow
proto="statisticsWindow"
left=487
top=94
tile=1
caption="Statistics"
type=1
helpContext=""
End CompInit
Dim basicStats as group
basicStats = MakeComponent("group",statisticsWindow)
CompInit basicStats
proto="basicStats"
caption="Basic"
look=1
sizeHControl=0
sizeVControl=0
width=145
height=280
visible=1
End CompInit
Dim label8 as label
label8 = MakeComponent("label",basicStats)
CompInit label8
proto="label8"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label8.name="label8"
Dim label9 as label
label9 = MakeComponent("label",basicStats)
CompInit label9
proto="label9"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label9.name="label9"
Dim label10 as label
label10 = MakeComponent("label",basicStats)
CompInit label10
proto="label10"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label10.name="label10"
Dim label11 as label
label11 = MakeComponent("label",basicStats)
CompInit label11
proto="label11"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label11.name="label11"
Dim label12 as label
label12 = MakeComponent("label",basicStats)
CompInit label12
proto="label12"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label12.name="label12"
Dim label13 as label
label13 = MakeComponent("label",basicStats)
CompInit label13
proto="label13"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label13.name="label13"
Dim label14 as label
label14 = MakeComponent("label",basicStats)
CompInit label14
proto="label14"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label14.name="label14"
Dim label15 as label
label15 = MakeComponent("label",basicStats)
CompInit label15
proto="label15"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label15.name="label15"
Dim label16 as label
label16 = MakeComponent("label",basicStats)
CompInit label16
proto="label16"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label16.name="label16"
Dim label17 as label
label17 = MakeComponent("label",basicStats)
CompInit label17
proto="label17"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label17.name="label17"
Dim label18 as label
label18 = MakeComponent("label",basicStats)
CompInit label18
proto="label18"
caption="Balance: "
sizeHControl=3
sizeVControl=3
left=7
top=187
visible=1
End CompInit
label18.name="label18"
Dim label19 as label
label19 = MakeComponent("label",basicStats)
CompInit label19
proto="label19"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label19.name="label19"
Dim spacer7 as spacer
spacer7 = MakeComponent("spacer",basicStats)
CompInit spacer7
proto="spacer7"
left=7
top=221
look=4
width=130
visible=1
End CompInit
spacer7.name="spacer7"
Dim label20 as label
label20 = MakeComponent("label",basicStats)
CompInit label20
proto="label20"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label20.name="label20"
Dim label21 as label
label21 = MakeComponent("label",basicStats)
CompInit label21
proto="label21"
caption=" "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label21.name="label21"
basicStats.name="basicStats"
statisticsWindow.name="statisticsWindow"
statisticsWindow.width=161
statisticsWindow.height=315
Dim busy1 as busy
busy1 = MakeComponent("busy","app")
CompInit busy1
proto="busy1"
End CompInit
busy1.name="busy1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

REM where is it black?
DIM boardColorInfo[ 8, 8] AS integer

REM computerMove/UserMove array...
DIM computerMove[ 5, 750] AS integer
DIM userMove[ 5, 750] AS integer
	DIM topMove AS integer


REM helper...
DIM nullComplex AS complex
DIM dirty AS integer

DIM num_moves AS integer
DIM num_user_moves AS integer

REM Statistics information variables...
DIM num_white_pawns AS integer
num_white_pawns = 8
DIM num_white_knights AS integer
num_white_knights = 2
DIM num_white_bishops AS integer
num_white_bishops = 2
DIM num_white_towers AS integer
num_white_towers = 2
DIM num_white_queens AS integer
num_white_queens = 1
DIM num_black_pawns AS integer
num_black_pawns = 8
DIM num_black_knights AS integer
num_black_knights = 2
DIM num_black_bishops AS integer
num_black_bishops = 2
DIM num_black_towers AS integer
num_black_towers = 2
DIM num_black_queens AS integer
num_black_queens = 1

DIM num_white_moves AS integer
DIM num_black_moves AS integer

REM Pawn promotion stuff
DIM promotionParty AS string
DIM promotionXPos AS integer
DIM promotionYPos AS integer

REM Set up a variable to check for a Win
DIM lastKilledPiece AS integer

REM Set up a variable to track which one_s turn it is
DIM turn AS integer
turn = 1

REM Set up a variable to store who_s won
DIM Won AS string

REM Here whe define of how many tiles a row consists
DIM boardWidth AS integer
	boardWidth = 8

REM Here whe calculate how big a tile is in Pixel
DIM tileWidth AS integer
	tileWidth = board.width/boardWidth

REM Here whe set up the array in which whe save the game information
DIM boardInfo[ boardWidth+2, boardWidth+2] AS  integer

REM Here whe define the variable needed to identify the transaction state
DIM transactionState AS integer

REM Here whe define a helper variable where whe store the selected piece
DIM selectedPiece AS integer

REM Here whe define helper variables for storing the last clicked tile
DIM XPos AS integer
DIM YPos AS integer
DIM XOrigin AS integer
DIM YOrigin AS integer

REM Here whe define a few Arrays whe need...
DIM moveInfo[ 10, 10] AS integer
DIM currentMoveInfo[ 10, 10] AS integer

REM chess_setup:
boardInfo[ 0, 0] = 4
boardInfo[ 1, 0] = 3
boardInfo[ 2, 0] = 2
boardInfo[ 3, 0] = 6
boardInfo[ 4, 0] = 5
boardInfo[ 5, 0] = 2
boardInfo[ 6, 0] = 3
boardInfo[ 7, 0] = 4

boardInfo[ 0, 1] = 1
boardInfo[ 1, 1] = 1
boardInfo[ 2, 1] = 1
boardInfo[ 3, 1] = 1
boardInfo[ 4, 1] = 1
boardInfo[ 5, 1] = 1
boardInfo[ 6, 1] = 1
boardInfo[ 7, 1] = 1

'boardInfo [ 4, 4] = 2

boardInfo[ 0, 6] = 7
boardInfo[ 1, 6] = 7
boardInfo[ 2, 6] = 7
boardInfo[ 3, 6] = 7
boardInfo[ 4, 6] = 7
boardInfo[ 5, 6] = 7
boardInfo[ 6, 6] = 7
boardInfo[ 7, 6] = 7

boardInfo[ 0, 7] = 10
boardInfo[ 1, 7] = 9
boardInfo[ 2, 7] = 8
boardInfo[ 3, 7] = 12
boardInfo[ 4, 7] = 11
boardInfo[ 5, 7] = 8
boardInfo[ 6, 7] = 9
boardInfo[ 7, 7] = 10

'picture1.graphic = getComplex(0)

log.visible = 1
board.visible = 1

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub gadget1_draw(self as gadget)



end sub

sub board_draw(self as gadget)

	REM Draw a nice white Backdrop
	self.DrawRect( 0, 0, self.width, self.height, WHITE)

	REM If you want a Grid to be drawn:
	drawGrid(self)

	REM Set up board according to the gameinfo in the array:
	REM whe make sure that the redraw works correctly, so whe parse the map and draw all entities

DIM i AS integer
DIM j AS integer
DIM n AS integer

FOR i = 0 TO boardWidth-1
	FOR j = 0 to boardWidth-1
		FOR n = 0 to 12
			IF boardInfo[ i, j] = n THEN
				self.DrawImage( getComplex(n-1),  tileWidth*i, tileWidth*j)
			END IF
		NEXT n
NEXT j
NEXT i


end sub

sub drawGrid(self AS gadget)

	DIM XCount AS integer
	DIM YCount AS integer
	
	FOR XCount = 0 to boardWidth-1
		self.DrawLine( 0, (self.width/boardWidth)*XCount, self.height, (self.width/boardWidth)*XCount, BLACK)
	NEXT XCount

	FOR YCount = 0 to boardWidth-1
		self.DrawLine( (self.height/boardWidth)*YCount,  0, (self.height/boardWidth)*YCount, self.width, BLACK)
	NEXT YCount

	self.DrawLine( self.width-1, 0, self.width-1, self.height-1, BLACK)
	self.DrawLine( 0, self.height-1, self.width, self.height-1, BLACK)

	REM Chess specific...
	setup_Chess_carre( tileWidth, boardWidth, self)

end sub

sub board_mouse(self as gadget, action as integer, flag as integer, X as integer, Y as integer, modifier as integer)

REM action = 1 means when clicked...

	XPos = X/tileWidth
	YPos = Y/tileWidth

IF action = 1 THEN 
	Update_Log( XPos, YPos, boardInfo[ XPos, YPos])
	Show_Tile( XPos, YPos)

REM board.width/boardWidth

	SELECT CASE transactionState
		CASE 0
			XOrigin = XPos
			YOrigin = YPos
			currentMoveInfo[ XOrigin, YOrigin] = 1
			State_0( XPos, YPos)
		CASE 1
			State_1( XPos, YPos)
		'CASE 2
		'	State_2( XPos, YPos)
	END SELECT
END IF

end sub

sub State_0( XPos AS integer, YPos AS integer)

DIM n AS integer
FOR n = 0 to 12
IF boardInfo[ XPos, YPos] <> 0 THEN
		IF sound.status = 1 THEN
			sound1.StandardSound(4)
		END IF
	transactionState = 1
	IF boardInfo[ XPos, YPos] = n THEN
		picture14.graphic = getComplex(n-1)
		selectedPiece = n
			label3.caption = "trnsState:  " + str(transactionState)
	SELECT CASE turn
	CASE 1
		SELECT CASE selectedPiece
			CASE 1
				bauer( XOrigin, YOrigin, "White")
			CASE 2
				laeufer( XOrigin, YOrigin, "White")
			CASE 3
				ross( XOrigin, YOrigin, "White")
			CASE 4
				turm( XOrigin, YOrigin, "White")
			CASE 5
				koenigin( XOrigin, YOrigin, "White")
			CASE 6
				koenig( XOrigin, YOrigin, "White")
		END SELECT
	CASE -1
		SELECT CASE selectedPiece
			CASE 7
				bauer( XOrigin, YOrigin, "Black")
			CASE 8
				laeufer( XOrigin, YOrigin, "Black")
			CASE 9
				ross( XOrigin, YOrigin, "Black")
			CASE 10
				turm( XOrigin, YOrigin, "Black")
			CASE 11
				koenigin( XOrigin, YOrigin, "Black")
			CASE 12
				koenig( XOrigin, YOrigin, "Black")
		END SELECT
	END SELECT
	END IF
'ELSE
'	sound1.StandardSound(1)
END IF
NEXT i

end sub

sub State_1( XPos AS integer, YPos AS integer)

IF currentMoveInfo[ XPos, YPos] <> 1 THEN
	Update_Log( XPos, YPos, 01234)
		IF moveInfo[ XPos, YPos] = 1 THEN
			transactionState = 0
			picture14.graphic = nullComplex
				lastKilledPiece = boardInfo[XPos, YPos]
				boardInfo[ XOrigin, YOrigin] = 0
				boardInfo[ XPos, YPos] = selectedPiece
			update_boardVisualisation( XOrigin, YOrigin, XPos, YPos, selectedPiece, board)
			Show_Valid_Fields(transactionState)
			Update_Log( XPos, YPos, 99)
				Reset_currentMoveInfo()
				Reset_moveInfo()
					IF sound.status = 1 THEN
						IF lastKilledPiece <> 0 THEN
							sound1.StandardSound(0)
						ELSE
							sound1.StandardSound(4)
						END IF
					END IF
			checkIfWon( lastKilledPiece)
			update_Stats()
			lastKilledPiece = 0
			checkIfPawnPromotion( XPos, YPos)
			nextTurn()
		ELSE
			sound1.StandardSound(3)
			transactionState = 0
			picture14.graphic = nullComplex
			'board.Redraw()
			Show_Valid_Fields(transactionState)
			Update_Log( XPos, YPos, 77)

				Reset_currentMoveInfo()
				Reset_moveInfo()
		END IF
ELSE
			sound1.StandardSound(4)
			transactionState = 0
			picture14.graphic = nullComplex
			'board.Redraw()
			Show_Valid_Fields(transactionState)
			Update_Log( XPos, YPos, 77)

	Reset_currentMoveInfo()
	Reset_moveInfo()
END IF

label3.caption = "trnsState:  " + str(transactionState)

end sub

sub State_2()

end sub

sub Update_Log( XPos AS integer, YPos AS integer, Action AS integer)

	log.text = log.text + "click"  + " X: " + str(XPos)  + " Y: " + str(YPos) + " Code: " + str(Action) + "\r"

end sub

sub Highlight_Rect( X AS integer, Y AS Integer, Action AS integer)

REM Prepare Calculus
'X = X/tileWidth
'Y = Y/tileWidth

REM Hotfix... :-)
Y = Y - 1

IF Action = 0 THEN
	board.DrawLine( X*tileWidth, (Y+1)*tileWidth, (X*tileWidth)+tileWidth, (Y*tileWidth)+tileWidth, BLACK)
	board.DrawLine( (X*tileWidth)+tileWidth, (Y+1)*tileWidth, (X*tileWidth)+tileWidth, ((Y+1)*tileWidth)+tileWidth, BLACK)
	board.DrawLine( X*tileWidth, (Y+1)*tileWidth, X*tileWidth, ((Y+1)*tileWidth)+tileWidth, BLACK)
	board.DrawLine( X*tileWidth, ((Y+1)*tileWidth)+tileWidth, (X*tileWidth)+tileWidth, ((Y+1)*tileWidth)+tileWidth, BLACK)
ELSE IF Action = 1 THEN
	board.DrawLine( X*tileWidth, (Y+1)*tileWidth, (X*tileWidth)+tileWidth, (Y*tileWidth)+tileWidth, LIGHT_RED)
	board.DrawLine( (X*tileWidth)+tileWidth, (Y+1)*tileWidth, (X*tileWidth)+tileWidth, ((Y+1)*tileWidth)+tileWidth, LIGHT_RED)
	board.DrawLine( X*tileWidth, (Y+1)*tileWidth, X*tileWidth, ((Y+1)*tileWidth)+tileWidth, LIGHT_RED)
	board.DrawLine( X*tileWidth, ((Y+1)*tileWidth)+tileWidth, (X*tileWidth)+tileWidth, ((Y+1)*tileWidth)+tileWidth, LIGHT_RED)
END IF

end sub

sub Show_Tile( XPos AS integer, YPos AS integer)

label2.caption = "Tile: " + "X: " + str(XPos+1) + " Y: "  + str(YPos+1)

end sub

sub Reset_moveInfo()

DIM i AS integer
DIM j AS integer

FOR i = 0 TO 7
	FOR j = 0 TO 7
		moveInfo[ i, j] = 0
	NEXT j
NEXT i

end sub

sub Show_Valid_Fields(Action AS integer)

DIM i AS integer
DIM j AS integer

FOR i = 0 TO 7
	FOR j = 0 TO 7
		IF moveInfo[ i, j] = 1
			Highlight_Rect( i, j, Action)
		END IF
	NEXT j
NEXT i

end sub

sub Clear_Log_pressed(self as button)

log.text = ""

end sub

sub bauer( XPos AS integer, YPos AS integer, Party AS string)

DIM dirty AS integer

SELECT CASE Party
CASE "White"
	IF YPos = 1 THEN
			IF boardInfo[ XPos, YPos + 1] = 0 THEN
			moveInfo[ XPos, YPos + 1] = 1
			ELSE
				dirty = 1
			END IF
			IF dirty = 0 THEN
				IF boardInfo[ XPos, YPos + 2] = 0 THEN
					moveInfo[ XPos, YPos + 2] = 1
				END IF
			END IF
		dirty = 0
	ELSE IF YPos = 8 THEN
			REM Award the player with a dialog box, where he can choose a piece, not implemented yet
	ELSE
		IF boardInfo[ XPos, YPos + 1] = 0 THEN
			moveInfo[ XPos, YPos + 1] = 1
		END IF
	END IF

	REM schlagen?
	IF XPos + 1 <= 8 THEN
		IF boardInfo[ XPos + 1, YPos + 1] > 6 AND boardInfo[ XPos + 1, YPos + 1] <> 0 THEN
			moveInfo[ XPos + 1, YPos + 1] = 1
		END IF
	END IF

	IF XPos - 1 >= 0 THEN
		IF boardInfo[ XPos - 1, YPos + 1] > 6 AND boardInfo[ XPos - 1, YPos + 1] <> 0 THEN
			moveInfo[ XPos - 1, YPos + 1] = 1
		END IF
	END IF

CASE "Black"
	IF YPos = 6 THEN
			IF boardInfo[ XPos, YPos - 1] = 0 THEN
				moveInfo[ XPos, YPos - 1] = 1
			ELSE
				dirty = 1
			END IF
			IF dirty = 0
				IF boardInfo[ XPos, YPos - 2] = 0 THEN
					moveInfo[ XPos, YPos - 2] = 1
				END IF
			END IF
		dirty = 0
	ELSE IF YPos = 0 THEN
		REM Award the player with a dialog box, where he can choose a piece, not implemented now

	ELSE
		IF boardInfo[ XPos, YPos - 1] = 0 THEN
			moveInfo[ XPos, YPos - 1] = 1
		END IF
	END IF

	REM schlagen?
	IF XPos + 1 >= 0 THEN
		IF boardInfo[ XPos + 1, YPos - 1] < 7 AND boardInfo[ XPos + 1, YPos - 1] <> 0 THEN
			moveInfo[ XPos + 1, YPos - 1] = 1
		END IF
	END IF

	IF XPos - 1 >= 0 THEN
		IF boardInfo[ XPos - 1, YPos - 1] < 7 AND boardInfo[ XPos - 1, YPos - 1] <> 0 THEN
			moveInfo[ XPos - 1, YPos - 1] = 1
		END IF
	END IF
END SELECT

	'calculateValidFields( Party)
	Show_Valid_Fields(transactionState)

end sub

sub Reset_currentMoveInfo()

DIM i AS integer
DIM j AS integer

FOR i = 0 TO 9
	FOR j =0 TO 9
		currentMoveInfo[ i, j] = 0
	NEXT j
NEXT i

end sub

sub turm( XPos AS integer, YPos AS integer, Party AS string)

DIM i AS integer
DIM j AS integer

DIM dirty AS integer

FOR i = XPos + 1 to 7
	IF dirty = 0 THEN
	IF boardInfo[ i, YPos] = 0 THEN
		moveInfo[ i, YPos] = 1
	ELSE IF boardInfo[ i, YPos] <> 0 THEN
		SELECT CASE Party
			CASE "White"
				IF boardInfo[ i, YPos] > 6 AND boardInfo[ i, YPos] <> 0 THEN
					moveInfo[ i, YPos] = 1
					dirty = 1
				ELSE
					dirty = 1
				END IF
			CASE "Black"
				IF boardInfo[ i, YPos] < 7 AND boardInfo[ i, YPos] <> 0 THEN
					moveInfo[ i, YPos] = 1
					dirty = 1
				ELSE
					dirty = 1
				END IF
			END SELECT
	ELSE
		EXIT FOR
	END IF
	END IF
NEXT i
dirty = 0

FOR i = XPos - 1 to 0  STEP -1
	IF dirty = 0 THEN
	IF boardInfo[ i, YPos] = 0 THEN
		moveInfo[ i, YPos] = 1
	ELSE IF boardInfo[ i, YPos] <> 0 THEN
		SELECT CASE Party
			CASE "White"
				IF boardInfo[ i, YPos] > 6 AND boardInfo[ i, YPos] <> 0 THEN
					moveInfo[ i, YPos] = 1
					dirty = 1
				ELSE
					dirty = 1
				END IF
			CASE "Black"
				IF boardInfo[ i, YPos] < 7 AND boardInfo[ i, YPos] <> 0 THEN
					moveInfo[ i, YPos] = 1
					dirty = 1
				ELSE
					dirty = 1
				END IF
			END SELECT
	ELSE
		EXIT FOR
	END IF
	END IF
NEXT i
dirty = 0

FOR i = YPos + 1 to 7
	IF dirty = 0 THEN
	IF boardInfo[ XPos, i] = 0 THEN
		moveInfo[ XPos, i] = 1
	ELSE IF boardInfo[ XPos, i] <> 0 THEN
		SELECT CASE Party
			CASE "White"
				IF boardInfo[ XPos, i] > 6 AND boardInfo[ XPos, i] <> 0 THEN
					moveInfo[ XPos, i] = 1
					dirty = 1
				ELSE
					dirty = 1
				END IF
			CASE "Black"
				IF boardInfo[ XPos, i] < 7 AND boardInfo[ XPos, i] <> 0 THEN
					moveInfo[ XPos, i] = 1
					dirty = 1
				ELSE
					dirty = 1
				END IF
			END SELECT
	ELSE
		EXIT FOR
	END IF
	END IF
NEXT i
dirty = 0

FOR i = YPos - 1 to 0  STEP -1
	IF dirty = 0 THEN
	IF boardInfo[ XPos, i] = 0 THEN
		moveInfo[ XPos, i] = 1
	ELSE IF boardInfo[ XPos, i] <> 0 THEN
		SELECT CASE Party
			CASE "White"
				IF boardInfo[ XPos, i] > 6 AND boardInfo[ XPos, i] <> 0 THEN
					moveInfo[ XPos, i] = 1
					dirty = 1
				ELSE
					dirty = 1
				END IF
			CASE "Black"
				IF boardInfo[ XPos, i] < 7 AND boardInfo[ XPos, i] <> 0 THEN
					moveInfo[ XPos, i] = 1
					dirty = 1
				ELSE
					dirty = 1
				END IF
			END SELECT
	ELSE
		EXIT FOR
	END IF
	END IF
NEXT i
dirty = 0

'DIM i AS integer
'DIM j AS integer
'
'FOR i = 0 TO 7
'	moveInfo[ i, YPos] = 1
'NEXT i
'
'FOR j = 0 TO 7
'	moveInfo[ XPos, j] = 1
'NEXT j

	'calculateValidFields( Party)
	Show_Valid_Fields(transactionState)

end sub

sub laeufer( XPos AS integer, YPos AS integer, Party AS string)

DIM i AS integer
DIM j AS integer

dirty = 0

REM i and j are the x and y part of the movevector
DO
	i = i + 1
	j = j + 1
		IF XPos + i >= 0 AND XPos + i < 8 AND YPos + j >= 0 AND YPos + j < 8 THEN
			IF boardInfo[ XPos + i, YPos + j] = 0 THEN
				moveInfo[ XPos + i, YPos + j] = 1
			ELSE
				SELECT CASE Party
					CASE "White"
						IF boardInfo[ XPos + i, YPos + j] > 6 THEN
							moveInfo[ XPos + i, YPos + j] = 1
							dirty = 1
						ELSE
							dirty = 1
						END IF
					CASE "Black"
						IF boardInfo[ XPos + i, YPos + j] < 7  THEN
							moveInfo[ XPos + i, YPos + j] = 1
							dirty = 1
						ELSE
							dirty = 1
						END IF
					END SELECT
				dirty = 1
			END IF
		ELSE
			dirty = 1
		END IF
LOOP UNTIL dirty
dirty = 0
i = 0
j = 0

DO
	i = i + 1
	j = j + 1
		IF XPos - i >= 0 AND XPos - i < 8 AND YPos - j >= 0 AND YPos - j < 8 THEN
			IF boardInfo[ XPos - i, YPos - j] = 0 THEN
				moveInfo[ XPos - i, YPos - j] = 1
			ELSE
				SELECT CASE Party
					CASE "White"
						IF boardInfo[ XPos - i, YPos - j] > 6 THEN
							moveInfo[ XPos - i, YPos - j] = 1
							dirty = 1
						ELSE
							dirty = 1
						END IF
					CASE "Black"
						IF boardInfo[ XPos - i, YPos - j] < 7  THEN
							moveInfo[ XPos - i, YPos - j] = 1
							dirty = 1
						ELSE
							dirty = 1
						END IF
					END SELECT
				dirty = 1
			END IF
		ELSE
			dirty = 1
		END IF
LOOP UNTIL dirty
dirty = 0
i = 0
j = 0

DO
	i = i + 1
	j = j + 1
		IF XPos + i >= 0 AND XPos + i < 8 AND YPos - j >= 0 AND YPos - j < 8 THEN
			IF boardInfo[ XPos + i, YPos - j] = 0 THEN
				moveInfo[ XPos + i, YPos - j] = 1
			ELSE
				SELECT CASE Party
					CASE "White"
						IF boardInfo[ XPos + i, YPos - j] > 6 THEN
							moveInfo[ XPos + i, YPos - j] = 1
							dirty = 1
						ELSE
							dirty = 1
						END IF
					CASE "Black"
						IF boardInfo[ XPos + i, YPos - j] < 7  THEN
							moveInfo[ XPos + i, YPos - j] = 1
							dirty = 1
						ELSE
							dirty = 1
						END IF
					END SELECT
				dirty = 1
			END IF
		ELSE
			dirty = 1
		END IF
LOOP UNTIL dirty
dirty = 0
i = 0
j = 0

DO
	i = i + 1
	j = j + 1
		IF XPos - i >= 0 AND XPos - i < 8 AND YPos + j >= 0 AND YPos + j < 8 THEN
			IF boardInfo[ XPos - i, YPos + j] = 0 THEN
				moveInfo[ XPos - i, YPos + j] = 1
			ELSE
				SELECT CASE Party
					CASE "White"
						IF boardInfo[ XPos - i, YPos + j] > 6 THEN
							moveInfo[ XPos - i, YPos + j] = 1
							dirty = 1
						ELSE
							dirty = 1
						END IF
					CASE "Black"
						IF boardInfo[ XPos - i, YPos + j] < 7  THEN
							moveInfo[ XPos - i, YPos + j] = 1
							dirty = 1
						ELSE
							dirty = 1
						END IF
					END SELECT
				dirty = 1
			END IF
		ELSE
			dirty = 1
		END IF
LOOP UNTIL dirty
dirty = 0
i = 0
j = 0


'FOR i = XPos TO 7
'	FOR j = YPos TO 7
'		IF i = j THEN
'			IF boardInfo[ i, j] = 0 THEN
'				moveInfo[ i, j] = 1
'			ELSE
'				EXIT FOR
'				EXIT FOR
'			END IF
'		END IF
'	NEXT j
'NEXT i
'
'FOR i = XPos TO 0 STEP - 1
'	FOR j = YPos TO 0 STEP - 1
'		IF i = j THEN
'			IF boardInfo[ i, j] = 0 THEN
'				moveInfo[ i, j] = 1
'			ELSE
'				EXIT FOR
'				EXIT FOR
'			END IF
'		END IF
'	NEXT j
'NEXT i
'
'FOR i = XPos TO 7
'	FOR j = YPos TO 0 STEP - 1
'		IF i = j THEN
'			IF boardInfo[ i, j] = 0 THEN
'				moveInfo[ i, j] = 1
'			ELSE
'				EXIT FOR
'				EXIT FOR
'			END IF
'		END IF
'	NEXT j
'NEXT i
'
'FOR i = XPos TO 0 STEP - 1
'	FOR j = YPos TO 7
'		IF i = j THEN
'			IF boardInfo[ i, j] = 0 THEN
'				moveInfo[ i, j] = 1	
'			ELSE
'				EXIT FOR
'				EXIT FOR
'			END IF
'		END IF
'	NEXT j
'NEXT i

REM old...
'FOR i = -7 TO 7 STEP 1
'	FOR j = -7 TO 7 STEP 1
'		IF XPos + i <= 7 AND XPos + i >= 0 THEN
'			IF YPos + j <= 7 AND YPos + j >= 0 THEN
'				IF abs(i) = abs(j) THEN
'					IF moveInfo[ XPos + i, YPos + j] < 1 OR moveInfo[ XPos + i, YPos + j] > 6 THEN
'						moveInfo[ XPos + i, YPos + j] = 1
'					END IF
'				END IF
'			END IF
'		END IF
'	NEXT j
'NEXT i

	'calculateValidFields( Party)
	Show_Valid_Fields(transactionState)


end sub

sub setup_Chess_carre( tileWidth AS integer, boardWidth AS integer, self AS gadget)

DIM i AS integer
DIM j AS integer

DIM counter AS float
DIM flip AS integer
DIM flop AS float

FOR i = 1 TO boardWidth
	counter = counter + 1
	flip = counter / 2
	flop = counter / 2
	FOR j = 1 TO boardWidth
	counter = counter + 1
	flip = counter / 2
	flop = counter / 2
		IF flip <> flop THEN
			boardColorInfo[ i - 1, j - 1] = 1
			'self.DrawRect( ((tileWidth * i) - tileWidth) + 1, ((tileWidth * j) - tileWidth) + 1, tileWidth * i, tileWidth * j, BLACK)
		END IF
	NEXT j
NEXT i

FOR i = 1 TO boardWidth
	FOR j = 1 TO boardWidth
		IF boardColorInfo[ i - 1, j - 1] = 1 THEN
			self.DrawRect( ((tileWidth * i) - tileWidth) + 1, ((tileWidth * j) - tileWidth) + 1, tileWidth * i, tileWidth * j, BLACK)
		END IF
	NEXT j
NEXT i


end sub

sub ross( XPos AS integer, YPos AS integer, Party AS string)

DIM i AS integer
DIM j AS integer

'IF XPos - 2 <= 7 AND XPos - 2 >= 0 AND YPos + 1 <= 7 AND YPos + 1 >= 0 THEN
'	moveInfo[ XPos - 2, YPos + 1] = 1
'END IF

FOR i = -2 TO 2 STEP 1
	IF i <> 0 THEN
	FOR j = -2 TO 2 STEP 1
		IF j <> 0 THEN
			IF XPos + i <= 7 AND XPos + i >= 0 THEN
				IF YPos + j <= 7 AND YPos + j >= 0 THEN
					IF abs(i) <> abs(j) THEN
						IF boardInfo[ XPos + i, YPos + j] = 0 THEN
							moveInfo[ XPos + i, YPos + j] = 1
						ELSE
							SELECT CASE Party
								CASE "White"
									IF boardInfo[ XPos + i, YPos + j] > 6 THEN
										moveInfo[ XPos + i, YPos + j] = 1
									END IF
								CASE "Black"
									IF boardInfo[ XPos + i, YPos + j] < 7  THEN
										moveInfo[ XPos + i, YPos + j] = 1
									END IF
							END SELECT
						END IF
						'checkParty( XPos +i, YPos + j, Party)
					END IF
				END IF
			END IF
		END IF
	NEXT j
	END IF
NEXT i

	'moveInfo[ XPos, YPos] = 1

	'calculateValidFields( Party)
	Show_Valid_Fields(transactionState)

end sub

sub koenig( XPos AS integer, YPos AS integer, Party AS string)

DIM i AS integer
DIM j AS integer

FOR i = -1 TO 1 STEP 1
	FOR j = -1 TO 1 STEP 1
		IF XPos + i <= 7 AND XPos + i >= 0 THEN
			IF YPos + j <= 7 AND YPos + j >= 0 THEN
				SELECT CASE Party
					CASE "White"
						IF boardInfo[ XPos + i, YPos + j] = 0 THEN
							moveInfo[ XPos + i, YPos + j] = 1
						ELSE IF boardInfo[ XPos + i, YPos + j] > 6 THEN
							moveInfo[ XPos + i, YPos + j] = 1
						END IF
					CASE "Black"
						IF boardInfo[ XPos + i, YPos + j] = 0 THEN
							moveInfo[ XPos + i, YPos + j] = 1
						ELSE IF boardInfo[ XPos + i, YPos + j] < 7 THEN
							moveInfo[ XPos + i, YPos + j] = 1
						END IF
				END SELECT
				'END IF
			END IF
		END IF
	NEXT j
NEXT i



	'calculateValidFields( Party)
	Show_Valid_Fields(transactionState)

end sub

sub checkParty( XPos AS integer, YPos AS integer, Party AS string)

IF boardInfo[ XPos, YPos] = 0 THEN
	moveInfo[ XPos, YPos] = 1
ELSE
	SELECT CASE Party
		CASE "White"
			IF boardInfo[ XPos, YPos] > 6 THEN
				moveInfo[ XPos, YPos] = 1
			END IF
		CASE "Black"
			IF boardInfo[ XPos, YPos] < 7  THEN
				moveInfo[ XPos, YPos] = 1
			END IF
	END SELECT
END IF


'SELECT CASE Party
'	CASE "White"
'		IF moveInfo[ XPos, YPos] >= 1 AND moveInfo[ XPos, YPos] <= 6 THEN
'			checkParty = 1
'		END IF
'	CASE "Black"
'		IF moveInfo[ XPos, YPos] >= 7 THEN
'			checkParty = 1
'		END IF
'END SELECT

end sub

sub koenigin( XPos AS integer, YPos AS integer, Party AS string)

'DIM i AS integer
'DIM j AS integer

'FOR i = XPos + 1 to 7
'	IF boardInfo[ i, YPos] = 0 THEN
'		moveInfo[ i, YPos] = 1
'	ELSE
'		EXIT FOR
'	END IF
'NEXT i
'
'FOR i = XPos - 1 to 0  STEP -1
'	IF boardInfo[ i, YPos] = 0 THEN
'		moveInfo[ i, YPos] = 1
'	ELSE
'		EXIT FOR
'	END IF
'NEXT i
'
'FOR i = YPos + 1 to 7
'	IF boardInfo[ XPos, i] = 0 THEN
'		moveInfo[ XPos, i] = 1
'	ELSE
'		EXIT FOR
'	END IF
'NEXT i
'
'FOR i = YPos - 1 to 0  STEP -1
'	IF boardInfo[ XPos, i] = 0 THEN
'		moveInfo[ XPos, i] = 1
'	ELSE
'		EXIT FOR
'	END IF
'NEXT i
'
'FOR i = XPos + 1 TO 7
'	FOR j = YPos + 1 TO 7
'		IF abs(i) = abs(j) THEN
'			IF boardInfo[ i, j] = 0 THEN
'				moveInfo[ i, j] = 1
'			ELSE
'				EXIT FOR
'			END IF
'		END IF
'	NEXT j
'NEXT i
'
'FOR i = XPos - 1 TO 0
'	FOR j = YPos - 1 TO 0
'		IF abs(i) = abs(j) THEN
'			IF boardInfo[ i, j] = 0 THEN
'				moveInfo[ i, j] = 1
'			ELSE
'				EXIT FOR
'			END IF
'		END IF
'	NEXT j
'NEXT i
'
'FOR i = XPos + 1 TO 7
'	FOR j = YPos - 1 TO 0
'		IF abs(i) = abs(j) THEN
'			IF boardInfo[ i, j] = 0 THEN
'				moveInfo[ i, j] = 1
'			ELSE
'				EXIT FOR
'			END IF
'		END IF
'	NEXT j
'NEXT i
'
'FOR i = XPos - 1 TO 0
'	FOR j = YPos + 1 TO 7
'		IF abs(i) = abs(j) THEN
'			IF boardInfo[ i, j] = 0 THEN
'				moveInfo[ i, j] = 1	
'			ELSE
'				EXIT FOR
'			END IF
'		END IF
'	NEXT j
'NEXT i

REM Original
'FOR i = -7 TO 7 STEP 1
'	FOR j = -7 TO 7 STEP 1
'		IF XPos + i <= 7 AND XPos + i >= 0 THEN
'			IF YPos + j <= 7 AND YPos + j >= 0 THEN
'				IF abs(i) = abs(j) OR i = 0 OR j = 0 THEN
'					'IF checkParty( XPos + 1, YPos + j, "White") = 1 THEN
'					moveInfo[ XPos + i, YPos + j] = 1
'					'END IF
'				END IF
'			END IF
'		END IF
'	NEXT j
'NEXT i

'	calculateValidFields( Party)
'	Show_Valid_Fields(transactionState)


turm( XPos, YPos, Party)
laeufer( XPos, YPos, Party)

end sub

sub checkIfWon( selectedPiece AS integer)

IF lastKilledPiece = 6 THEN
	Won = "Black"
ELSE IF lastKilledPiece = 12 THEN
	Won = "White"
ELSE IF lastKilledPiece = 1 THEN
	num_white_pawns = num_white_pawns - 1
ELSE IF lastKilledPiece = 2 THEN
	num_white_bishops = num_white_bishops - 1
ELSE IF lastKilledPiece = 3 THEN
	num_white_knights = num_white_knights - 1
ELSE IF lastKilledPiece = 4 THEN
	num_white_towers = num_white_towers - 1
ELSE IF lastKilledPiece = 5 THEN
	num_white_queens = num_white_queens - 1
ELSE IF lastKilledPiece = 7 THEN
	num_black_pawns = num_black_pawns - 1
ELSE IF lastKilledPiece = 8 THEN
	num_black_bishops = num_black_bishops - 1
ELSE IF lastKilledPiece = 9 THEN
	num_black_knights = num_black_knights - 1
ELSE IF lastKilledPiece = 10 THEN
	num_black_towers = num_black_towers - 1
ELSE IF lastKilledPiece = 11 THEN
	num_black_queens = num_black_queens - 1
END IF

IF selectedPiece < 7 THEN
		num_white_moves = num_white_moves + 1
ELSE
		num_black_moves = num_black_moves + 1
END IF

IF Won <> "" THEN
	'Won_String.caption = Won + " has Won! Congratulation!"
	SELECT CASE Won
		CASE "White"
			Won_String.caption = Won + " has Won with only " + str(num_white_moves) + "Moves! Congratulation!"
		CASE "Black"
			Won_String.caption = Won + " has Won with only " + str(num_black_moves) + "Moves! Congratulation!"
	END SELECT
	dialog2.visible = 1
		IF sound.status = 1 THEN
			sound1.StandardSound(0)
		END IF
	Won = ""
END IF

end sub

sub OK_pressed(self as button)

	Won_String.caption = ""
	Won = ""
	reset_BoardInfo()

end sub

sub reset_BoardInfo()

DIM i AS integer
DIM j AS integer

FOR i = 0 TO 7
	FOR j = 0 TO 7
		boardInfo[ i, j] = 0
	NEXT j
NEXT i


REM chess_setup:
boardInfo[ 0, 0] = 4
boardInfo[ 1, 0] = 3
boardInfo[ 2, 0] = 2
boardInfo[ 3, 0] = 6
boardInfo[ 4, 0] = 5
boardInfo[ 5, 0] = 2
boardInfo[ 6, 0] = 3
boardInfo[ 7, 0] = 4

boardInfo[ 0, 1] = 1
boardInfo[ 1, 1] = 1
boardInfo[ 2, 1] = 1
boardInfo[ 3, 1] = 1
boardInfo[ 4, 1] = 1
boardInfo[ 5, 1] = 1
boardInfo[ 6, 1] = 1
boardInfo[ 7, 1] = 1

boardInfo[ 0, 6] = 7
boardInfo[ 1, 6] = 7
boardInfo[ 2, 6] = 7
boardInfo[ 3, 6] = 7
boardInfo[ 4, 6] = 7
boardInfo[ 5, 6] = 7
boardInfo[ 6, 6] = 7
boardInfo[ 7, 6] = 7

boardInfo[ 0, 7] = 10
boardInfo[ 1, 7] = 9
boardInfo[ 2, 7] = 8
boardInfo[ 3, 7] = 12
boardInfo[ 4, 7] = 11
boardInfo[ 5, 7] = 8
boardInfo[ 6, 7] = 9
boardInfo[ 7, 7] = 10

REM reset Satistics
num_white_pawns = 8
num_white_bishops = 2
num_white_knights = 2
num_white_towers = 2
num_white_queens = 1
num_black_pawns = 8
num_black_bishops = 2
num_black_knights = 2
num_black_towers = 2
num_black_queens = 1
num_white_moves = 0
num_black_moves = 0

update_Stats()

board.Redraw()

end sub

sub calculateValidFields( Party AS string)

DIM i AS integer
DIM j AS integer

FOR i = 0 TO 7
	FOR j = 0 TO 7
		IF moveInfo[ i, j] = 1 THEN
			SELECT CASE Party
				CASE "White"
					IF boardInfo[ i, j] > 0 AND boardInfo[ i, j] < 7 THEN
						moveInfo[ i, j] = 0
					END IF
				CASE "Black"
					IF boardInfo[ i, j] > 6 AND boardInfo[ i, j] < 12 THEN
						moveInfo[ i, j] = 0
					END IF
			END SELECT
		END IF
	NEXT j
NEXT i

end sub

sub timer1_ring(self as timer)

computer( "Black")

end sub

sub Restart_pressed(self as button)

reset_BoardInfo()
turn = 1
label7.caption = "White"

end sub

sub nextTurn()

turn = turn * -1

IF turn = 1 THEN
	label7.caption = "White"
ELSE
	label7.caption = "Black"
END IF

IF turn = -1 THEN
	IF computer.status = 1 THEN
		computer( "Black")
	END IF
END IF


end sub

sub checkIfPawnPromotion( XPos AS integer, YPos AS integer)

IF YPos = 7 THEN
	IF boardInfo[ XPos, YPos] = 1 THEN
			REM White
			promotionParty = "White"
			promotionXPos = XPos
			promotionYPos = YPos
			button4.graphic = picture3.graphic
			button5.graphic = picture4.graphic
			button6.graphic = picture5.graphic
			button7.graphic = picture6.graphic
				dialog3.visible = 1
	END IF
ELSE IF YPos = 0 THEN
	IF boardInfo[ XPos, YPos] = 7 THEN
			promotionParty = "Black"
			promotionXPos = XPos
			promotionYPos = YPos
			button4.graphic = picture9.graphic
			button5.graphic = picture10.graphic
			button6.graphic = picture11.graphic
			button7.graphic = picture12.graphic
				dialog3.visible = 1
	END IF
END IF

end sub

sub button4_pressed(self as button)

IF 	promotionParty = "White" THEN
	boardInfo[ promotionXPos, promotionYPos] = 2
END IF

IF 	promotionParty = "Black" THEN
	boardInfo[ promotionXPos, promotionYPos] = 8
END IF

board.Redraw()

end sub

sub button5_pressed(self as button)

IF 	promotionParty = "White" THEN
	boardInfo[ promotionXPos, promotionYPos] = 3
END IF

IF 	promotionParty = "Black" THEN
	boardInfo[ promotionXPos, promotionYPos] = 9
END IF

board.Redraw()

end sub

sub button6_pressed(self as button)

IF 	promotionParty = "White" THEN
	boardInfo[ promotionXPos, promotionYPos] = 4
END IF

IF 	promotionParty = "Black" THEN
	boardInfo[ promotionXPos, promotionYPos] = 10
END IF

board.Redraw()

end sub

sub button7_pressed(self as button)

IF 	promotionParty = "White" THEN
	boardInfo[ promotionXPos, promotionYPos] = 5
END IF

IF 	promotionParty = "Black" THEN
	boardInfo[ promotionXPos, promotionYPos] = 11
END IF

board.Redraw()

end sub

sub update_Stats()

label8.caption = "White Pawns: " + str(num_white_pawns)
label9.caption = "White Bishops: " + str(num_white_bishops)
label10.caption = "White Knights: " + str(num_white_knights)
label11.caption = "White Towers: " + str(num_white_towers)
label12.caption = "White Queens: " + str(num_white_queens)
label13.caption = "Black Pawns: " + str(num_black_pawns)
label14.caption = "Black Bishops: " + str(num_black_bishops)
label15.caption = "Black Knights: " + str(num_black_knights)
label16.caption = "Black Towers: " + str(num_black_towers)
label17.caption = "Black Queens: " + str(num_black_queens)

label20.caption = "White Moves: " + str(num_white_moves)
label21.caption = "Black Moves: " + str(num_black_moves)

DIM white_total AS integer
DIM black_total AS integer
white_total = num_white_pawns + (num_white_bishops * 2) +  (num_white_knights * 2) + (num_white_towers * 2) + (num_white_queens * 5)
black_total = num_black_pawns + (num_black_bishops * 2) +  (num_black_knights * 2) + (num_black_towers * 2) + (num_black_queens * 5)
label19.caption = "White: " + str(white_total) + " to Black: " +  str(black_total)

end sub

sub stats_changed(self as toggle)

IF stats.status = 1 THEN
	statisticsWindow.visible = 1
ELSE
	statisticsWindow.visible = 0
END IF

end sub

sub update_boardVisualisation( XOrigin AS integer, YOrigin AS integer, XPos AS integer, YPos AS integer, selectedPiece AS integer, self AS gadget)

DIM i AS integer
DIM j AS integer

i = XOrigin + 1
j = YOrigin + 1
IF boardColorInfo[ XOrigin, YOrigin] = 1 THEN
	self.DrawRect( ((tileWidth * i) - tileWidth) + 1, ((tileWidth * j) - tileWidth) + 1, tileWidth * i, tileWidth * j, BLACK)
ELSE
	self.DrawRect( ((tileWidth * i) - tileWidth) + 1, ((tileWidth * j) - tileWidth) + 1, tileWidth * i, tileWidth * j, WHITE)
END IF
	self.DrawImage( getComplex( boardInfo[ XOrigin, YOrigin] - 1), tileWidth * XOrigin, tileWidth * YOrigin)

i = XPos + 1
j = YPos + 1
IF boardColorInfo[ XPos, YPos] = 1 THEN
	self.DrawRect( ((tileWidth * i) - tileWidth) + 1, ((tileWidth * j) - tileWidth) + 1, tileWidth * i, tileWidth * j, BLACK)
ELSE
	self.DrawRect( ((tileWidth * i) - tileWidth) + 1, ((tileWidth * j) - tileWidth) + 1, tileWidth * i, tileWidth * j, WHITE)
END IF
	self.DrawImage( getComplex( boardInfo[ XPos, YPos] - 1), tileWidth * XPos, tileWidth * YPos)


end sub

sub computer( Party AS string)

REM put up hourglasses...
	busy1.Enter()

DIM i AS integer
DIM j AS integer
DIM dirty AS integer

REM reset computerMove/userMove
FOR i = 0 TO 4
	FOR j = 0 TO 749
		computerMove[ i, j] = 0
	NEXT j
NEXT i
FOR i = 0 TO 4
	FOR j = 0 TO 749
		userMove[ i, j] = 0
	NEXT j
NEXT i
topMove = 0

REM setup movetable...
	computer_calc_moves()
	computer_calc_enemy_moves()

Show_Valid_Fields( 1)

REM ***************************************
REM * Move sort... which is the best Move?

'DIM danger AS integer

	REM find best Move
	topMove = 0
	FOR i = num_moves TO 0 STEP -1
		IF computerMove[ 4, i] > topMove THEN
			REM if no danger at all then "just do it(tm)"
			IF moveInfo[ computerMove[ 2, i], computerMove[ 3, i]] = 0 THEN
				topMove = i
			REM else evaluate the risk!
			REM hmm, gotta think of something!
			ELSE 'IF moveInfo[ computerMove[ 2, i], computerMove[ 3, i]] > (moveInfo[ computerMove[ 0, i], computerMove[ 1, i]] - 6) THEN
				FOR j = 0 to num_user_moves
					IF moveInfo[computerMove[ 2, i], computerMove[ 3, i]] > (userMove[ 4, j] - 6) THEN
						topMove = i
					END IF
				NEXT j
			END IF
		END IF
	NEXT i

REM else do something...
DO WHILE topMove = 0
	topMove = int( num_moves * rnd())
	IF boardInfo[ computerMove[ 0, topMove], computerMove[ 1, topMove]] = 12 THEN
		topMove = 0
	END IF		
LOOP

REM do move...
selectedPiece = boardInfo[ computerMove[ 0, topMove], computerMove[ 1, topMove]]
lastKilledPiece = boardInfo[ computerMove[ 2, topMove], computerMove[ 3, topMove]]
boardInfo[ computerMove[ 2, topMove], computerMove[ 3, topMove]] =  boardInfo[ computerMove[ 0, topMove], computerMove[ 1, topMove]]
boardInfo[ computerMove[ 0, topMove], computerMove[ 1, topMove]] = 0
update_boardVisualisation( computerMove[ 0, topMove],  computerMove[ 1, topMove],  computerMove[ 2, topMove],  computerMove[ 3, topMove],  computerMove[ 4, topMove], board)
label22.caption = "Last Move: " + str(computerMove[ 2, topMove]) + "/" + str(computerMove[ 3, topMove]) + " to " + str(computerMove[ 0, topMove]) + "/" + str(computerMove[ 1, topMove])

IF sound.status = 1 THEN
	IF lastKilledPiece <> 0 THEN
		sound1.StandardSound(0)
	ELSE
		sound1.StandardSound(4)
	END IF
END IF

Show_Valid_Fields( 0)
Reset_moveInfo()

	num_black_moves = num_black_moves + 1
	checkIfWon( lastKilledPiece)
	update_Stats()
	checkIfPawnPromotion( computerMove[ 2, topMove], computerMove[ 3, topMove])

nextTurn()
busy1.Leave()

end sub

sub button8_pressed(self as button)

'IF timer1.enabled = 0 THEN
'	timer1.enabled = 1
'ELSE
'	timer1.enabled = 0
'END IF

computer( "Black")

end sub

sub computer_calc_moves()

DIM i AS integer
DIM j AS integer
DIM x AS integer
DIM y AS integer
DIM dirty AS integer

num_moves = 0

REM Calculate possible moves...
FOR i = 0 TO 7
	FOR j = 0 TO 7
		SELECT CASE boardInfo[ i, j]
			CASE 7
				bauer( i, j, "Black")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								computerMove[ 0, num_moves] = i
								computerMove[ 1, num_moves] = j
								computerMove[ 2, num_moves] = x
								computerMove[ 3, num_moves] = y
								computerMove[ 4, num_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
			CASE 8
				laeufer( i, j, "Black")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								computerMove[ 0, num_moves] = i
								computerMove[ 1, num_moves] = j
								computerMove[ 2, num_moves] = x
								computerMove[ 3, num_moves] = y
								computerMove[ 4, num_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
			CASE 9
				ross( i, j, "Black")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								computerMove[ 0, num_moves] = i
								computerMove[ 1, num_moves] = j
								computerMove[ 2, num_moves] = x
								computerMove[ 3, num_moves] = y
								computerMove[ 4, num_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
			CASE 10
				turm( i, j, "Black")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								computerMove[ 0, num_moves] = i
								computerMove[ 1, num_moves] = j
								computerMove[ 2, num_moves] = x
								computerMove[ 3, num_moves] = y
								computerMove[ 4, num_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
			CASE 11
				koenigin( i, j, "Black")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								computerMove[ 0, num_moves] = i
								computerMove[ 1, num_moves] = j
								computerMove[ 2, num_moves] = x
								computerMove[ 3, num_moves] = y
								computerMove[ 4, num_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
			CASE 12
				koenig( i, j, "Black")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								computerMove[ 0, num_moves] = i
								computerMove[ 1, num_moves] = j
								computerMove[ 2, num_moves] = x
								computerMove[ 3, num_moves] = y
								computerMove[ 4, num_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
		END SELECT
	Reset_moveInfo()
	IF dirty = 1 THEN
		num_moves = num_moves + 1
		dirty = 0
	END IF
	NEXT j
NEXT i

end sub

sub computer_calc_enemy_moves()

DIM i AS integer
DIM j AS integer
DIM x AS integer
DIM y AS integer
DIM dirty AS integer
num_user_moves = 0

REM Calculate possible moves...
FOR i = 0 TO 7
	FOR j = 0 TO 7
		SELECT CASE boardInfo[ i, j]
			CASE 1
				bauer( i, j, "White")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								userMove[ 0, num_user_moves] = i
								userMove[ 1, num_user_moves] = j
								userMove[ 2, num_user_moves] = x
								userMove[ 3, num_user_moves] = y
								userMove[ 4, num_user_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
			CASE 2
				laeufer( i, j, "White")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								userMove[ 0, num_user_moves] = i
								userMove[ 1, num_user_moves] = j
								userMove[ 2, num_user_moves] = x
								userMove[ 3, num_user_moves] = y
								userMove[ 4, num_user_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
			CASE 3
				ross( i, j, "White")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								userMove[ 0, num_user_moves] = i
								userMove[ 1, num_user_moves] = j
								userMove[ 2, num_user_moves] = x
								userMove[ 3, num_user_moves] = y
								userMove[ 4, num_user_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
			CASE 4
				turm( i, j, "White")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								userMove[ 0, num_user_moves] = i
								userMove[ 1, num_user_moves] = j
								userMove[ 2, num_user_moves] = x
								userMove[ 3, num_user_moves] = y
								userMove[ 4, num_user_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
			CASE 5
				koenigin( i, j, "White")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								userMove[ 0, num_user_moves] = i
								userMove[ 1, num_user_moves] = j
								userMove[ 2, num_user_moves] = x
								userMove[ 3, num_user_moves] = y
								userMove[ 4, num_user_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
			CASE 6
				koenig( i, j, "White")
					FOR x = 0 TO 7
						FOR y = 0 TO 7
							IF moveInfo[ x, y] = 1 THEN
								userMove[ 0, num_user_moves] = i
								userMove[ 1, num_user_moves] = j
								userMove[ 2, num_user_moves] = x
								userMove[ 3, num_user_moves] = y
								userMove[ 4, num_user_moves] = boardInfo[ x, y]
								dirty = 1
							END IF
						NEXT y
					NEXT x
		END SELECT
	'Reset_moveInfo()
	IF dirty = 1 THEN
		num_user_moves = num_user_moves + 1
		dirty = 0
	END IF
	NEXT j
NEXT i

end sub

